EZY Project/Controllers/FileUploadController.cs
using BAL.Repositories;
//using CsvHelper;
using DAL.DBEntities;
using Newtonsoft.Json;
using OfficeOpenXml;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.OleDb;
using System.Data.SqlClient;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace EZY_Project.Controllers
{
    public class uploadfile
    {
        public string Type { get; set; }
        public string Year { get; set; }
        public string Month { get; set; }
    }
    public class FileUploadController : BaseController
    {
        // GET: FileUpload
        FileUploadRepository fileuploadrepo;
        public FileUploadController()
        {
            fileuploadrepo = new FileUploadRepository(new OMSEntities());
        }
        public ActionResult Index()
        {
            //ViewBag.Year = fileuploadrepo.GetYearMonth().Select(x=>x.OrderDate.ToString("YYYY"));
            var year = (from c in fileuploadrepo.GetYearMonth()
                        select new { Year = c.OrderDate.Value.ToString("yyyy"), Month = c.OrderDate.Value.ToString("MM"), MonthName = c.OrderDate.Value.ToString("MMM") }).ToList();
            ViewBag.Year = year.Select(x => new { Year = x.Year }).Distinct().ToList();
            ViewBag.Month = year.Select(x => new { Month = x.Month, MonthName = x.MonthName }).Distinct().ToList();

            //ViewBag.Month =;
            return View();
        }
        [HttpPost]
        public ActionResult GetFilesData()
        {

            var allcustomer = fileuploadrepo.GetInvoivesData();
            var abc = JsonConvert.SerializeObject(allcustomer, Formatting.Indented, new JsonSerializerSettings { ReferenceLoopHandling = ReferenceLoopHandling.Ignore });

            var result = Json(new { data = abc }, JsonRequestBehavior.AllowGet);
            result.MaxJsonLength = int.MaxValue;
            return result;
        }
        [HttpPost]
        public ActionResult upload(uploadfile ProductName, HttpPostedFileBase file)
        {
            bool isSavedSuccessfully = false;

            foreach (string fileName in Request.Files)
            {
                //HttpPostedFileBase file = Request.Files[fileName];
                if (System.IO.Path.GetExtension(file.FileName) == ".xlsx" || System.IO.Path.GetExtension(file.FileName) == ".xls")
                {
                    string _FileName = System.IO.Path.GetFileName(file.FileName);
                    string _path = System.IO.Path.Combine(Server.MapPath("~/UploadedFiles"), DateTime.Now.ToString("dd-MM-yyyy") + System.IO.Path.GetExtension(file.FileName));
                    file.SaveAs(_path);
                    DataTable dt = ConvertExcelToDataTable(_path, true);
                    //if (!_FileName.Contains("EZYTechnologiesPvt.Ltd."))
                    //{
                    var dValue = from row in dt.AsEnumerable()
                                 where row.Field<string>("Regions") == "PK"
                                 select row;
                    foreach (var item in dValue)
                    {
                        if (fileName.Contains("Software-Subscriptions"))
                        {
                            GetByProductID(item["ProductId"].ToString(), item["SKUId"].ToString(), item["ListPrice"].ToString(), item["Msrp"].ToString());
                        }
                        else if (fileName.Contains("Cloud-Reseller-Pricelist"))
                        {
                            GetByOfferID(item["Offer ID"].ToString(), item["List Price"].ToString(), item["ERP Price"].ToString());
                        }
                    }
                    //}

                }
                else if (System.IO.Path.GetExtension(file.FileName) == ".csv")
                {
                    string _FileName = System.IO.Path.GetFileName(file.FileName);
                    string _path = System.IO.Path.Combine(Server.MapPath("~/UploadedFiles"), DateTime.Now.ToString("dd-MM-yyyy") + System.IO.Path.GetExtension(file.FileName));
                    file.SaveAs(_path);
                    //readCsv(_path);
                    SqlBulk(_path, ProductName.Type,ProductName);
                }

                //You can Save the file content here

                isSavedSuccessfully = true;
            }

            return View("Index");
        }

        public static DataTable ConvertExcelToDataTable(string path, bool hasHeader)
        {
            try
            {
                DataSet ds = new DataSet();
                using (var pck = new ExcelPackage())
                {
                    using (var stream = System.IO.File.OpenRead(path))
                    {
                        pck.Load(stream);
                    }
                    ExcelWorksheets sheets = pck.Workbook.Worksheets;
                    try
                    {


                        //for (int s = 1; s <= sheets.Count; s++)
                        {
                            var ws = sheets[1];
                            DataTable tbl = new DataTable();
                            foreach (var firstRowCell in ws.AutoFilterAddress != null ? ws.Cells[ws.AutoFilterAddress.Start.Row, ws.Dimension.Start.Column, ws.AutoFilterAddress.Start.Row, ws.Dimension.End.Column] : ws.Cells[ws.SelectedRange.Start.Row, ws.Dimension.Start.Column, ws.SelectedRange.Start.Row, ws.Dimension.End.Column])
                            //foreach (var firstRowCell in ws.Cells[ws.Dimension.Start.Row, ws.Dimension.Start.Column, ws.Dimension.Start.Row, ws.Dimension.End.Column])
                            {
                                if (!tbl.Columns.Contains(firstRowCell.Text))
                                {
                                    tbl.Columns.Add(hasHeader ? firstRowCell.Text : string.Format("Column {0}", firstRowCell.Start.Column));
                                }
                                else
                                {
                                    return ds.Tables[0];
                                }
                            }
                            var startRow = hasHeader ? ws.AutoFilterAddress == null ? ws.SelectedRange.Start.Row + 1 : ws.AutoFilterAddress.Start.Row + 1 : 1;
                            for (int rowNum = startRow; rowNum <= ws.Dimension.End.Row; rowNum++)
                            {
                                var wsRow = ws.Cells[rowNum, 1, rowNum, ws.Dimension.End.Column];
                                DataRow row = tbl.Rows.Add();
                                foreach (var cell in wsRow)
                                {
                                    row[cell.Start.Column - 1] = cell.Text;
                                }
                            }
                            //      var emptyRows =
                            //tbl.Select()
                            //    .Where(
                            //        row =>
                            //            tbl.Columns.Cast<DataColumn>()
                            //                .All(column => string.IsNullOrEmpty(row[column].ToString()))).ToArray();
                            //      Array.ForEach(emptyRows, x => x.Delete());

                            //      var emptyColumns =
                            //          tbl.Columns.Cast<DataColumn>()
                            //              .Where(column => tbl.Select().All(row => string.IsNullOrEmpty(row[column].ToString())))
                            //              .ToArray();
                            //      Array.ForEach(emptyColumns, column => tbl.Columns.Remove(column));
                            //      tbl.AcceptChanges();

                            tbl.TableName = ws.Name;
                            ds.Tables.Add(tbl);
                        }
                    }
                    catch (Exception ex)
                    {
                        ds.Tables[0].TableName = "Error";
                        return ds.Tables[0];
                    }

                    return ds.Tables[0];

                }
            }
            catch (Exception ex)
            {
                throw ex;
            }
            //int i = 0;

        }
        public static string ConnectionString = new OMSEntities().Database.Connection.ConnectionString.ToString();//System.Configuration.ConfigurationManager.AppSettings["ConnectionString"];
        public static void GetByProductID(string ProductID, string SKUID, string List_Price, string MSRP)
        {
            //var con = "Data Source=DESKTOP-GVQ6T7E;Initial Catalog=OMS;Connection Timeout=1000;user id=sa;password=viftech;";

            using (SqlConnection myConnection = new SqlConnection(ConnectionString))
            {
                string oString = "Select * from vt_ProductDetails where MCID=@MCID  and skuId=@skuId";
                SqlCommand oCmd = new SqlCommand(oString, myConnection);
                oCmd.Parameters.AddWithValue("@MCID", ProductID);
                oCmd.Parameters.AddWithValue("@skuId", SKUID);
                myConnection.Open();
                using (SqlDataReader oReader = oCmd.ExecuteReader())
                {
                    while (oReader.Read())
                    {

                        string Updatequery = "Update vt_ProductDetails set ListPrice='" + List_Price + "',Msrp='" + MSRP + "' where MCID=@MCID  and skuId=@skuId";
                        //          System.Data.SqlClient.SqlConnection sqlConnection1 =
                        //new System.Data.SqlClient.SqlConnection("Data Source=DESKTOP-GVQ6T7E;Initial Catalog=OMS;Connection Timeout=1000;user id=sa;password=viftech;");

                        System.Data.SqlClient.SqlConnection sqlConnection1 =
             new System.Data.SqlClient.SqlConnection(ConnectionString);

                        System.Data.SqlClient.SqlCommand cmd = new System.Data.SqlClient.SqlCommand();

EZY Project/Controllers/InvoiceController.cs
using BAL.Repositories;
using DAL.DBEntities;
using EZY_Project.Models;
using iTextSharp.text;
using iTextSharp.text.pdf;
using iTextSharp.tool.xml;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace EZY_Project.Controllers
{
    public class InvoiceController : Controller
    {
        // GET: Invoice
        public ActionResult Index()
        {
            return View();
        }
        public void DownloadInvoice()
        {
            string viewPrint = "View";
            int CustomerId = Convert.ToInt32(Request.RawUrl.Split('/')[3].Split('-')[0]);
            //int month=  Convert.ToInt32(Request.RawUrl.Split('/')[3].Split('-')[1]);
            //int year = Convert.ToInt32(Request.RawUrl.Split('/')[3].Split('-')[2]);
            //string Type= Request.RawUrl.Split('/')[3].Split('-')[3];


            InvoiceStructure model = new CustomerRepository().GetCustomerById(CustomerId);
            string dataa = PartialView(viewPrint, model).RenderToString(this.ControllerContext);
            //dataa = dataa.Replace("/Content", folderPath);


            // vt_Common.RenderPartialToString(this, "PrintViewData", ModelData, VDD, TDD);
            StringReader sr = new StringReader(dataa);//Request.Form[hfGridHtml.UniqueID]
            Document pdfDoc = new Document(PageSize.A4, 10f, 10f, 20f, 20f);
            PdfWriter writer = PdfWriter.GetInstance(pdfDoc, Response.OutputStream);
            pdfDoc.Open();
            XMLWorkerHelper.GetInstance().ParseXHtml(writer, pdfDoc, sr);
            pdfDoc.Close();
            //string file = HostingEnvironment.MapPath("~/Template/clientregularization.pdf");
            Response.ContentType = "application/pdf";
            Response.AddHeader("content-disposition", "attachment;filename= Certificate.pdf");
            Response.Cache.SetCacheability(HttpCacheability.NoCache);

            Response.Write(pdfDoc);
            Response.OutputStream.Flush();
            Response.End();
        }
    }
}

EZY Project/Controllers/OrderController.cs
using BAL.Repositories;
using DAL;
using DAL.DBEntities;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace EZY_Project.Controllers
{
    //Test
    public class OrderController : BaseController
    {
        public OrderRepository Orderrepo;
        public OrderController()
        {
            Orderrepo = new OrderRepository(new OMSEntities());
        }
        // GET: Order
        public ActionResult Index()
        {
            Order order = new Order();
            order._Customer = CurrentUser._Customer;
            //order.CustomerName=CurrentUser.
            IList<vt_Cart> carts = JsonConvert.DeserializeObject<List<vt_Cart>>((Request.Cookies["Cart"]).Value);
            int[] arrayCartID = carts.Select(x => x.ID).ToArray();
            order.Cart = Orderrepo.GetOrder(arrayCartID);
            return View(order);
        }

        [HttpGet]
        public ActionResult OrderConfirmation()
        {
            bool Status = false;
            string message = string.Empty;
            try
            {
                IList<vt_Cart> carts = JsonConvert.DeserializeObject<List<vt_Cart>>((Request.Cookies["Cart"]).Value);
                int[] arrayCartID = carts.Select(x => x.ID).ToArray();
                Status=Orderrepo.CreateOrder(arrayCartID,CurrentUser.user.Email,CurrentUser.user.Password,CurrentUser.User);
            }
            catch(Exception ex)
            {
                message = ex.Message;
            }


            return Json(new { success = Status,message= message }, JsonRequestBehavior.AllowGet);//RedirectToAction("Index", "Product");
        }


        public ActionResult Modules()
        {            
            Customer _customer = new Customer();
            OMSSession sess = (OMSSession)System.Web.HttpContext.Current.Session["OMSSession"];
            sess.CustomerID = Convert.ToInt32(Request.RawUrl.Split('/')[3]);
            _customer = Orderrepo.GetCustomerMicrosoftID(Convert.ToInt32(Request.RawUrl.Split('/')[3]));
            sess._Customer = _customer;
            Session.Add("OMSSession", sess);
            //Request.RawUrl.Split('/')[3]
            return View("OrderHistory", _customer);
            //return View(Orderrepo.GetOrderbyCustomerID(Convert.ToInt32(Request.RawUrl.Split('/')[3])));
        }

        public ActionResult Orders()
        {
            return PartialView("_Order", Orderrepo.GetOrderbyCustomerID(CurrentUser.CustomerID));
        }

        public ActionResult Subscriptions()
        {
            return PartialView("_Subscriptions", Orderrepo.GetSubscriptionByCustomerID(CurrentUser.CustomerID));
        }
    }
}

EZY Project/Views/FileUpload/Index.cshtml
@model DAL.DBEntities.vt_Invoice_P
@{
    ViewBag.Title = "Index";
    Layout = "~/Views/Shared/_Layout.cshtml";
}
<style>
    /*.dz-error-message {
        display: none !important;
    }*/
</style>

<div class="row page-title clearfix">
    <div class="page-title-left">
        <h6 class="page-title-heading mr-0 mr-r-5">File Upload</h6>
    </div>
    <!-- /.page-title-left -->
    <div class="page-title-right d-none d-sm-inline-flex">
        <ol class="breadcrumb">
            <li class="breadcrumb-item">
                <a href="index.html">Dashboard</a>
            </li>
            <li class="breadcrumb-item active">File Upload</li>
        </ol>
    </div>
    <!-- /.page-title-right -->
</div>
<!-- /.page-title -->
<!-- =================================== -->
<!-- Different data widgets ============ -->
<!-- =================================== -->
<div class="widget-list">
    <div class="row">
        <div class="col-md-12 widget-holder">
            <div class="widget-bg">
                <div class="widget-body clearfix">
                    <h5 class="box-title mr-b-0">File Upload 1</h5>
                    <p class="text-muted"></p>

                    @*@Html.DropDownList("year", new SelectList(ViewBag.Year, "Year", "Year"), "Please Select",
    new Dictionary<string, Object> { { "class", "form-control" }, { "data-live-search", "true" }, { "data-max-options", "1" } })
                    @Html.DropDownList("month", new SelectList(ViewBag.Month, "Month", "MonthName"), "Please Select",
    new Dictionary<string, Object> { { "class", "form-control" }, { "data-live-search", "true" }, { "data-max-options", "1" } })*@
                    @Html.TextBox("Years",null, new { @class = "form-control", @title = "Year", Placeholder = "Year", AutoCompleteType = "Disabled", validate = "validate_data", require = "*Please enter year" })
                    <select class="form-control" id="ddlMonth">
                        <option value="0">Please Select</option>
                        <option value="1">January</option>
                        <option value="2">February</option>
                        <option value="3">March</option>
                        <option value="4">April</option>
                        <option value="5">May</option>
                        <option value="6">June</option>
                        <option value="7">July</option>
                        <option value="8">August</option>
                        <option value="9">September</option>
                        <option value="10">October</option>
                        <option value="11">November</option>
                        <option value="12">December</option>
                    </select>
                    <select class="form-control"  id="ddltype">
                        <option value="PleaseSelect">Please Select</option>
                        <option value="Azure">Azure</option>
                        <option value="Office">Office</option>
                        <option value="OnlineService">OnlineService</option>
                    </select>
@using (Html.BeginForm("upload", "FileUpload", FormMethod.Post, new { enctype = "multipart/form-data" }))
{
    <div class="fallback">
        <input type="file" name="file" id="file1">
    </div>
                        <!-- /.fallback -->
                        <div class="dz-message" data-dz-message>
                            <span>Drop files here to upload</span>
                        </div>
                        @Html.Hidden("Month");
    @Html.Hidden("Year");
    @Html.Hidden("Type");
    <button type="submit" class="btn btn-pinterest ripple" id="btnUpload"><i class="material-icons list-icon"></i>  <span>Upload</span></button>
}
                    @*<form action="~/FileUpload/upload" enctype = "multipart/form-data">

                      
                    </form>*@
                </div>
                <!-- /.widget-body -->
            </div>
            <!-- /.widget-bg -->
        </div>
        <!-- /.widget-holder -->
        
        <!-- /.widget-holder -->
        
        <!-- /.widget-holder -->
    </div>
    <!-- /.row -->
</div>



@section InScript{
    <link href="~/assets/css/dropzone.min.css" rel="stylesheet" type="text/css">
    <link href="~/assets/css/basic.min.css" rel="stylesheet" type="text/css">
    @*<script src="~/assets/js/dropzone.js"></script>*@
    <script src="~/assets/js/dropzone.min.js"></script>
    @*<script src="~/assets/js/app.js"></script>*@

    <script type="text/javascript">
        $(document).ready(function () {
            $('#demoupload').hide();
            $("#btnUpload").click(function () {
                alert("test");
            });
           
            $("#ddltype").change(function () {
                //$('#ddltype :selected').text();
                $('#Type').val($('#ddltype').val());
                if($('#ddltype').val().trim()!="PleaseSelect".trim())
                {
                    //
                    if ($('#Years').val().trim() != "" && $('#ddlMonth').val().trim() != "Please Select".trim())
                    {
                        $('#Year').val($('#Years').val());
                        $('#Month').val($('#ddlMonth :selected').val());
                        $('#demoupload').show();
                    }
                    else
                    {
                        alert("Select Year and Month ");
                    }
                }
                else
                {
                    $('#demoupload').hide();
                }
            });
            Dropdzoneupload();

            //Dropzone.options.uploads = {
            //    acceptedFiles: ".xlsx,.csv",
            //    autoProcessQueue: true,
            //    parallelUploads: 20
            //};

            //Dropzone.options.dropzoneJsForm = {
            //    paramName: "file",
            //    maxFilesize: 20,
            //    maxFiles: 4,
            //    uploadMultiple: true,
            //    parallelUploads: 6,
            //    acceptedFiles: ".xlsx",
            //    dictMaxFilesExceeded: "Custom max files msg",
            //    //prevents Dropzone from uploading dropped files immediately
            //    autoProcessQueue: false,
            //    init: function () {
            //        var submitButton = document.querySelector("#submit-all");
            //        var myDropzone = this; //closure

            //        submitButton.addEventListener("click", function () {

            //            //tell Dropzone to process all queued files
            //            myDropzone.processQueue();
            //        });
            //        this.on("complete", function (data) {
            //            //var res = eval('(' + data.xhr.responseText + ')');
            //            var res = JSON.parse(data.xhr.responseText);
            //        });
            //    }
            //};
        })

        function LoadFilesdata()
        {
            $.ajax({
                url: '/FileUpload/GetFilesData',
                type: 'Post',
                success: function (response) {
                    var data = JSON.parse(response.data)
                    $("#devCustomerDataGrid").dxDataGrid({
                        dataSource: data,
                        showBorders: true,
                        columnsAutoWidth: true,
                        showBorders: true,
                        filterRow: {
                            visible: true,
                            applyFilter: "auto"
                        },
                        headerFilter: {
                            visible: true
                        },
                        paging: {
                            pageSize: 10
                        },
                        pager: {
                            showPageSizeSelector: true,
                            allowedPageSizes: [5, 10, 20],
                            showInfo: true
                        },
                        columns: [
                            {

                                //caption: "Company"
                                caption: "Company",
                                dataField: "Company",
                                cellTemplate: function (container, options) {
                                    var html = "<a class='CustomerLink' href='@Url.Action("Modules", "Order")/" + options.data.ID + "' _MCID=" + options.data.CustomerMCID + "><span>" + options.data.Company + "</span></a>";
                                    $(html)
                           .appendTo(container);
                                }

                            }
                        ,
                            "CompanyAccount", {
                                caption: "Relationship",
                                calculateCellValue: function (data) {
                                    return "Cloud Reseller"
                                }
                            }, {

                                caption: "Action",
                                cellTemplate: function (container, options) {
                                    var html = "<a class='btn btn-pinterest tbl_expend_btn ripple' href='@Url.Action("Subscriptions", "Customer")/" + options.data.ID + "'><span>Add Subscriptions</span></a>";
                                    //html += "<a class='btn btn-pinterest tbl_expend_btn ripple' _id=" + options.data.ID + " id='btnpdfInvoice' href='@Url.Action("DownloadInvoice", "Invoice")/" + options.data.ID + "'> <i class='fa fa-file-pdf-o'></i> &nbsp;&nbsp; <span> Invoice</span></a>";
                                    $(html)
                           .appendTo(container);
                                }

                            }
                        ]
                    });


                },
                error: function (xhr) {
                    console.log(xhr);
                }
            });
        }


        function Dropdzoneupload() {

            Dropzone.autoDiscover = false;
            Dropzone.options.demoupload = {
                //var dZone = new Dropzone('#demoupload', {
                //url: "~/FileUpload/upload",
                autoProcessQueue: false,
                init: function () {
                    //var submitButton = document.querySelector("#btnSubmit");
                    var myDropzone = this;
                    //myDropzone.on("sending", function (file, xhr, formData) {
                    //    console.log("asd")
                    //    formData.append("ProductName", "Hello");
                    //});

                    //submitButton.addEventListener("click", function () {
                    //    myDropzone.processQueue();

                    //});

                }
            };
            //});
            
            Dropzone.options.demoupload.init();

            //new Dropzone('#demo-upload', {
            //    //autoDiscover: false,
            //    url: "~/FileUpload/upload",
            //    autoProcessQueue: false,
            //    //paramName: "file",
            //    //uploadMultiple: true,
            //    //addRemoveLinks: true,
            //    //maxFiles: 6,
            //    //acceptedFiles: "image/jpeg,image/jpg,image/png,image/gif",
            //    //parallelUploads: 6,
            //    init: function () {
            //        //var submitButton = document.querySelector("#submit-all");
            //        myDropzone = this; //closure

            //        myDropzone.on("sending", function (file, xhr, formData) {
            //            console.log("sending");
            //            formData.append("ProductName", 'bob');
            //        });


            //        //submitButton.addEventListener("click", function () {

            //        //    //tell Dropzone to process all queued files
            //        //    myDropzone.processQueue();
            //        //});



            //        //myDropzone.on("success", function (files, response) {
            //        //    console.log(response);
            //        //});
            //    }
            //});
        }
    </script>
}